=== debian/changelog ===
veracrypt (1.24+update3-0.1~mx19+1) mx; urgency=medium

  * New upstream release.
  * Refresh 001-indicator-support.patch.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 10 Jan 2020 15:58:47 -0800
